<template>
    <v-data-table
      :headers="headers"
      :items="lapData"
      dense
      class="elevation-1"
    >
      <template v-slot:top>
        <v-toolbar
          flat
        >
          <v-toolbar-title>ベストラップ</v-toolbar-title>
          <v-divider
            class="mx-4"
            inset
            vertical
          ></v-divider>
          <v-spacer></v-spacer>
          <v-dialog
            v-model="dialog"
          >
            <template v-slot:activator="{ on, attrs }">
              <v-btn
                color="primary"
                dark
                small
                v-bind="attrs"
                v-on="on"
              >
                新規追加
              </v-btn>
            </template>
            <v-card>
              <v-card-title>
                <span class="text-h5">{{ formTitle }}</span>
              </v-card-title>
  
              <v-card-text>
                <v-container>
                  <v-row>
                    <v-col
                      cols="12"
                      sm="6"
                      md="4"
                    >
                      <inline-date-picker
                        v-model="editedItem.date"
                        label="走行日"
                      ></inline-date-picker>
                    </v-col>
                    <v-col
                      cols="12"
                      sm="6"
                      md="4"
                    >
                      <v-combobox
                        v-model="editedItem.climate"
                        label="気候"
                        :items="selects.climates"
                        dense
                      ></v-combobox>
                    </v-col>
                    <v-col
                      cols="12"
                      sm="6"
                      md="4"
                    >
                      <v-combobox
                        v-model="editedItem.circuit"
                        label="コース"
                        :items="selects.circuits"
                        dense
                      ></v-combobox>
                    </v-col>
                    <v-col
                      cols="12"
                      sm="6"
                      md="4"
                    >
                      <v-text-field
                        v-model="editedItem.laptime"
                        label="ラップタイム"
                      ></v-text-field>
                    </v-col>
                    <v-col
                      cols="12"
                      sm="6"
                      md="4"
                    >
                      <v-text-field
                        v-model="editedItem.ftires"
                        label="Fタイヤ"
                      ></v-text-field>
                    </v-col>
                    <v-col
                      cols="12"
                      sm="6"
                      md="4"
                    >
                      <v-text-field
                        v-model="editedItem.rtires"
                        label="Rタイヤ"
                      ></v-text-field>
                    </v-col>
                  </v-row>
                </v-container>
              </v-card-text>
  
              <v-card-actions>
                <v-spacer></v-spacer>
                <v-btn
                  color="blue darken-1"
                  text
                  @click="close"
                >
                  Cancel
                </v-btn>
                <v-btn
                  color="blue darken-1"
                  text
                  @click="save"
                >
                  Save
                </v-btn>
              </v-card-actions>
            </v-card>
          </v-dialog>
          <v-dialog v-model="dialogDelete" max-width="500px">
            <v-card>
              <v-card-title class="text-h5">削除しますか？</v-card-title>
              <v-card-actions>
                <v-spacer></v-spacer>
                <v-btn color="blue darken-1" text @click="closeDelete">Cancel</v-btn>
                <v-btn color="blue darken-1" text @click="deleteItemConfirm">OK</v-btn>
                <v-spacer></v-spacer>
              </v-card-actions>
            </v-card>
          </v-dialog>
        </v-toolbar>
      </template>
      <template v-slot:[`item.actions`]="{ item }">
        <v-icon
          small
          class="mr-2"
          @click="editItem(item)"
        >
          mdi-pencil
        </v-icon>
        <v-icon
          small
          @click="deleteItem(item)"
        >
          mdi-delete
        </v-icon>
      </template>
    </v-data-table>
</template>

<script>
import InlineDatePicker from '~/components/InlineDatePicker.vue'
export default {
  components: { InlineDatePicker },

  mounted: function() {
    if (localStorage.getItem('lapData')) {
      try {
        this.lapData = JSON.parse(localStorage.getItem('lapData'));
      } catch(e) {
        localStorage.removeItem('lapData');
      }
    }
  },

  data: () => ({
    dialog: false,
    dialogDelete: false,
    headers: [
      { text: '走行日', value: 'date' },
      { text: '天候', value: 'climate' },
      { text: 'コース', value: 'circuit' },
      { text: 'ベストラップ', value: 'laptime' },
      { text: 'Fタイヤ', value: 'ftires' },
      { text: 'Rタイヤ', value: 'rtires' },
      { text: '操作', value: 'actions', sortable: false },
    ],
    selects: {
      circuits: [
        'リンクサーキット',
        'TC2000',
        'TC1000',
        'ナリタ右',
        'ナリタ左',
      ],
      climates: [
        'ドライ',
        'ウェット',
        'ハーフウェット'
      ],
    },
    lapData: [],
    editedIndex: -1,
    editedItem: {
      date: (new Date(Date.now() - (new Date()).getTimezoneOffset() * 60000)).toISOString().substr(0, 10),
      climate: '',
      circuit: '',
      laptime: '',
      ftires: '',
      rtires: '',
    },
    defaultItem: {
      date: (new Date(Date.now() - (new Date()).getTimezoneOffset() * 60000)).toISOString().substr(0, 10),
      climate: '',
      circuit: '',
      laptime: '',
      ftires: '',
      rtires: '',
    },
  }),

  computed: {
    formTitle () {
      return this.editedIndex === -1 ? '新規追加' : '更新'
    },
  },

  watch: {
    dialog (val) {
      val || this.close()
    },
    dialogDelete (val) {
      val || this.closeDelete()
    },
  },

  created () {
    this.initialize()
  },

  methods: {
    initialize () {
      this.lapData = [
      ]
    },

    editItem (item) {
      this.editedIndex = this.lapData.indexOf(item)
      this.editedItem = Object.assign({}, item)
      this.dialog = true
    },

    deleteItem (item) {
      this.editedIndex = this.lapData.indexOf(item)
      this.editedItem = Object.assign({}, item)
      this.dialogDelete = true
    },

    deleteItemConfirm () {
      this.lapData.splice(this.editedIndex, 1)
      const parsed = JSON.stringify(this.lapData);
      localStorage.setItem('lapData', parsed);
      this.closeDelete()
    },

    close () {
      this.dialog = false
      this.$nextTick(() => {
        this.editedItem = Object.assign({}, this.defaultItem)
        this.editedIndex = -1
      })
    },

    closeDelete () {
      this.dialogDelete = false
      this.$nextTick(() => {
        this.editedItem = Object.assign({}, this.defaultItem)
        this.editedIndex = -1
      })
    },

    save () {
      if (this.editedIndex > -1) {
        Object.assign(this.lapData[this.editedIndex], this.editedItem)
      } else {
        this.lapData.unshift(this.editedItem)
      }
      const parsed = JSON.stringify(this.lapData);
      localStorage.setItem('lapData', parsed);
      this.close()
    },
  },
}
</script>